import getNodeScroll from './getNodeScroll';
import getOffsetParent from './getOffsetParent';

var sumScroll = function sumScroll(scrollParents) {
  return scrollParents.reduce(function (scroll, scrollParent) {
    var nodeScroll = getNodeScroll(scrollParent);
    scroll.scrollTop += nodeScroll.scrollTop;
    scroll.scrollLeft += nodeScroll.scrollLeft;
    return scroll;
  }, {
    scrollTop: 0,
    scrollLeft: 0
  });
};

export default function getCommonTotalScroll(reference, referenceScrollParents, popperScrollParents, limiter) {
  var offsetParent = getOffsetParent(reference);
  var index = referenceScrollParents.findIndex(function (node) {
    return node === (limiter || offsetParent);
  });
  var scrollParents = referenceScrollParents.slice(0, index === -1 ? undefined : index);
  return sumScroll(scrollParents);
}