import getBasePlacement from '../utils/getBasePlacement';
import addClientRectMargins from '../dom-utils/addClientRectMargins';
import getElementClientRect from '../dom-utils/getElementClientRect';
import getCommonTotalScroll from '../dom-utils/getCommonTotalScroll';
import getMainAxisFromPlacement from '../utils/getMainAxisFromPlacement';
import within from '../utils/within';
export function arrow(state, options) {
  var _state$modifiersData$;

  if (options === void 0) {
    options = {};
  }

  var _options = options,
      _options$element = _options.element,
      arrowElement = _options$element === void 0 ? '[data-popper-arrow]' : _options$element; // CSS selector

  if (typeof arrowElement === 'string') {
    arrowElement = state.elements.popper.querySelector(arrowElement);

    if (!arrowElement) {
      return state;
    }
  }

  if (!state.elements.popper.contains(arrowElement)) {
    if (process.env.NODE_ENV !== "production") {
      console.error('Popper: "arrow" modifier\'s `element` must be a child of the popper element.');
    }

    return state;
  }

  state.elements.arrow = arrowElement;
  var popperOffsets = state.modifiersData.popperOffsets;
  var basePlacement = getBasePlacement(state.placement);
  var axis = getMainAxisFromPlacement(basePlacement);
  var isVertical = ['left', 'right'].includes(basePlacement);
  var len = isVertical ? 'height' : 'width';
  var arrowElementRect = addClientRectMargins(getElementClientRect(arrowElement), arrowElement);
  var commonTotalScroll = getCommonTotalScroll(state.elements.reference, state.scrollParents.reference, state.scrollParents.popper);
  var endDiff = state.measures.reference[len] + state.measures.reference[axis] - popperOffsets[axis] - state.measures.popper[len];
  var startDiff = popperOffsets[axis] - state.measures.reference[axis]; // Only center to reference if the popper is longer than reference along the
  // axis

  var centerToReference = state.measures.popper[len] > state.measures.reference[len] ? endDiff / 2 - startDiff / 2 - commonTotalScroll[axis === 'y' ? 'scrollTop' : 'scrollLeft'] : 0;
  var center = state.measures.popper[len] / 2 - arrowElementRect[len] / 2 + centerToReference; // Make sure the arrow doesn't overflow the popper if the center point is
  // outside of the popper bounds

  center = within(0, center, state.measures.popper[len] - arrowElementRect[len]); // Prevents breaking syntax highlighting...

  var axisProp = axis;
  state.modifiersData.arrow = (_state$modifiersData$ = {}, _state$modifiersData$[axisProp] = center, _state$modifiersData$);
  return state;
}
export default {
  name: 'arrow',
  enabled: true,
  phase: 'main',
  fn: arrow,
  requires: ['popperOffsets']
};