// source: https://stackoverflow.com/questions/49875255
var order = function order(modifiers) {
  // indexed by name
  var mapped = modifiers.reduce(function (mem, i) {
    mem[i.name] = i;
    return mem;
  }, {}); // inherit all dependencies for a given name

  var inherited = function inherited(i) {
    return mapped[i] && mapped[i].requires ? mapped[i].requires.reduce(function (mem, i) {
      return [].concat(mem, [i], inherited(i));
    }, []) : [];
  }; // order ...


  var ordered = modifiers.sort(function (a, b) {
    return !!~inherited(b.name).indexOf(a.name) ? -1 : 1;
  });
  return ordered;
};

export default (function (modifiers) {
  return [].concat(order(modifiers.filter(function (_ref) {
    var phase = _ref.phase;
    return phase === 'read';
  })), order(modifiers.filter(function (_ref2) {
    var phase = _ref2.phase;
    return phase === 'main';
  })), order(modifiers.filter(function (_ref3) {
    var phase = _ref3.phase;
    return phase === 'afterMain';
  })), order(modifiers.filter(function (_ref4) {
    var phase = _ref4.phase;
    return phase === 'write';
  })));
});